SystemOrganization addCategory: #'Orca-Unfinished-Pong'!

OrcaWidget subclass: #OrcaPongClient
	instanceVariableNames: 'paddle playfield'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Unfinished-Pong'!

OrcaPongClient class
	instanceVariableNames: 'uniqueInstance'!

OrcaPongClient class
	instanceVariableNames: 'uniqueInstance'!

!OrcaPongClient class methodsFor: 'as yet unclassified' stamp: 'robi 5/18/2011 14:16'!
isOrcaRootComponent 

	 ^ true
	! !

!OrcaPongClient class methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 17:10'!
orcaSessionClass 

	^ OrcaRemoteObjectsSession ! !

!OrcaPongClient class methodsFor: 'as yet unclassified' stamp: 'robi 5/18/2011 14:15'!
orcaTitle

	^ 'Pong'! !

!OrcaPongClient class methodsFor: 'as yet unclassified' stamp: 'robi 5/24/2011 14:30'!
requiredClasses 

	 ^ { OrcaHeading. OrcaPongPlayfield. OrcaPongPaddleView. }! !

!OrcaPongClient class methodsFor: 'as yet unclassified' stamp: 'robi 5/24/2011 14:17'!
requiredScripts
	
	^ #( 'misc/raphael-min.js' )! !

!OrcaPongClient class methodsFor: 'as yet unclassified' stamp: 'robi 5/18/2011 14:38'!
requiredStyles

	^ { 'pong.css' }! !

!OrcaPongClient class methodsFor: 'as yet unclassified' stamp: 'robi 5/18/2011 14:14'!
uniquePath 

	^ 'pong'! !

!OrcaPongClient methodsFor: 'as yet unclassified' stamp: 'robi 5/24/2011 15:05'!
addPaddleViewFor: aPongPaddleModel
	| newPaddleView |
	
	newPaddleView := OrcaPongPaddleView newOn: playfield canvas.
	
	aPongPaddleModel views add: newPaddleView.
	self add: newPaddleView.! !

!OrcaPongClient methodsFor: 'as yet unclassified' stamp: 'robi 5/24/2011 15:23'!
initialize
	super initialize.
	
	self playfield: OrcaPongPlayfield new.
	self playfield initializeCanvas.
	
	self 
		add: (OrcaHeading new text: 'Pong');
		add: self playfield.

	" to be removed "		
	OrcaPongPaddleView newOn: self playfield canvas.
		
	" to be used "
"	self paddle: (OrcaPongManager asRemote playfield addPaddleFor: self)."
! !

!OrcaPongClient methodsFor: 'accessing' stamp: 'robi 5/23/2011 16:05'!
paddle
	^ paddle! !

!OrcaPongClient methodsFor: 'accessing' stamp: 'robi 5/23/2011 16:05'!
paddle: anObject
	paddle := anObject! !

!OrcaPongClient methodsFor: 'accessing' stamp: 'robi 5/24/2011 14:27'!
playfield
	^ playfield! !

!OrcaPongClient methodsFor: 'accessing' stamp: 'robi 5/24/2011 14:27'!
playfield: anObject
	playfield := anObject! !

OrcaWidget subclass: #OrcaPongPaddleModel
	instanceVariableNames: 'views'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Unfinished-Pong'!

!OrcaPongPaddleModel methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 16:55'!
angle: anAngle
	
	self views do: [ :each | each angle: anAngle ].! !

!OrcaPongPaddleModel methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 18:22'!
initialize
	self views: OrderedCollection new.! !

!OrcaPongPaddleModel methodsFor: 'accessing' stamp: 'robi 5/23/2011 16:48'!
views
	^ views! !

!OrcaPongPaddleModel methodsFor: 'accessing' stamp: 'robi 5/23/2011 16:48'!
views: anObject
	views := anObject! !

OrcaWidget subclass: #OrcaPongPaddleView
	instanceVariableNames: 'canvas rectangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Unfinished-Pong'!

!OrcaPongPaddleView class methodsFor: 'as yet unclassified' stamp: 'robi 5/18/2011 14:51'!
cssClass

	^ 'paddle'! !

!OrcaPongPaddleView class methodsFor: 'as yet unclassified' stamp: 'robi 5/18/2011 15:09'!
defaultHeight
	^ '10px'! !

!OrcaPongPaddleView class methodsFor: 'as yet unclassified' stamp: 'robi 5/18/2011 15:09'!
defaultWidth
	^ '100px'! !

!OrcaPongPaddleView class methodsFor: 'as yet unclassified' stamp: 'robi 5/18/2011 14:45'!
htmlElementType

	^ 'div'! !

!OrcaPongPaddleView class methodsFor: 'as yet unclassified' stamp: 'robi 5/24/2011 15:07'!
newOn: aCanvas

	^
	self basicNew
		canvas: aCanvas;
		initialize;
		yourself.! !

!OrcaPongPaddleView methodsFor: 'accessing' stamp: 'robi 5/24/2011 15:15'!
angle: anAngle
	
	"true for absolute positioning"
	self rectangle rotate value: anAngle value: true.! !

!OrcaPongPaddleView methodsFor: 'accessing' stamp: 'robi 5/24/2011 15:07'!
canvas
	^ canvas! !

!OrcaPongPaddleView methodsFor: 'accessing' stamp: 'robi 5/24/2011 15:07'!
canvas: anObject
	canvas := anObject! !

!OrcaPongPaddleView methodsFor: 'accessing' stamp: 'robi 5/24/2011 15:15'!
extent: aPoint

	self rectangle attr value: {#width -> aPoint x. #height -> aPoint y } asObject.! !

!OrcaPongPaddleView methodsFor: 'initialization' stamp: 'robi 5/24/2011 15:17'!
initialize
	
	super initialize.

	self rectangle: (self canvas rect value: 40 value: 40 value: 50 value: 20).
	self rectangle attr value: {#fill -> 'red'} asObject.
	
	self angle: 45.
	self origin: 10@10.
	self extent: 100@20.! !

!OrcaPongPaddleView methodsFor: 'accessing' stamp: 'robi 5/24/2011 15:15'!
origin: aPoint

	self rectangle attr value: {#x -> aPoint x. #y -> aPoint y } asObject.! !

!OrcaPongPaddleView methodsFor: 'accessing' stamp: 'robi 5/24/2011 15:26'!
rectangle
	^ rectangle! !

!OrcaPongPaddleView methodsFor: 'accessing' stamp: 'robi 5/24/2011 15:26'!
rectangle: anObject
	rectangle := anObject! !

OrcaWidget subclass: #OrcaPongPlayfield
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Unfinished-Pong'!

!OrcaPongPlayfield class methodsFor: 'as yet unclassified' stamp: 'robi 5/24/2011 15:21'!
defaultHeight

	^ 400! !

!OrcaPongPlayfield class methodsFor: 'as yet unclassified' stamp: 'robi 5/24/2011 15:21'!
defaultWidth

	^ 400! !

!OrcaPongPlayfield class methodsFor: 'configuration' stamp: 'robi 5/24/2011 14:33'!
htmlElementType

	^ 'div'! !

!OrcaPongPlayfield methodsFor: 'accessing' stamp: 'robi 5/24/2011 15:20'!
canvas
	^ canvas! !

!OrcaPongPlayfield methodsFor: 'accessing' stamp: 'robi 5/24/2011 15:20'!
canvas: anObject
	canvas := anObject! !

!OrcaPongPlayfield methodsFor: 'as yet unclassified' stamp: 'robi 5/24/2011 15:25'!
initializeCanvas

	self cssId: 'playfield'.
	
	self canvas: (Js Global Raphael value: self node value: self class defaultWidth value: self class defaultHeight).
! !

!OrcaPongPlayfield methodsFor: 'as yet unclassified' stamp: 'robi 5/24/2011 15:19'!
onLoad

	self cssId: 'playfield'.
	
	self canvas: Js Global Raphael value: self node value: self class defaultWidth value: self class defaultHeight.
! !

Object subclass: #OrcaPongGame
	instanceVariableNames: 'paddles clients'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Unfinished-Pong'!

!OrcaPongGame methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 16:49'!
addPaddleFor: aPongClient
	| newPaddle |

	self paddles do: [ :eachPaddle | aPongClient addPaddleViewFor: eachPaddle ].

	self clients add: aPongClient.
	newPaddle := OrcaPongPaddleModel new.
	self paddles add: newPaddle.

	self clients do: [ :eachClient | eachClient addPaddleViewFor: newPaddle ].
	self repositionPaddles.
	
	^newPaddle! !

!OrcaPongGame methodsFor: 'accessing' stamp: 'robi 5/23/2011 16:30'!
clients
	^ clients! !

!OrcaPongGame methodsFor: 'accessing' stamp: 'robi 5/23/2011 16:30'!
clients: anObject
	clients := anObject! !

!OrcaPongGame methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 16:29'!
initialize
	
	super initialize.
	
	self paddles: OrderedCollection new.
	self clients: OrderedCollection new.! !

!OrcaPongGame methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 16:09'!
paddles
	
	^ paddles! !

!OrcaPongGame methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 16:09'!
paddles: aPaddleCollection
	
	paddles := aPaddleCollection! !

!OrcaPongGame methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 16:46'!
repositionPaddles
	
	1 to: self paddles size do: [ :index |
		| paddle |
		
		paddle := self paddles at: index.
		
		paddle angle: (360 * (index - 1) / self paddles size).
	].
! !

Object subclass: #OrcaPongManager
	instanceVariableNames: 'playfield'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Unfinished-Pong'!

OrcaPongManager class
	instanceVariableNames: 'uniqueInstance'!

OrcaPongManager class
	instanceVariableNames: 'uniqueInstance'!

!OrcaPongManager class methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 14:29'!
new

	^Error signal: 'this is a singelton. use uniqueInstance'! !

!OrcaPongManager class methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 14:27'!
playfield

	^self uniqueInstance playfield! !

!OrcaPongManager class methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 14:29'!
uniqueInstance

	^ uniqueInstance ifNil: [ self basicNew initialize ].! !

!OrcaPongManager methodsFor: 'as yet unclassified' stamp: 'robi 5/24/2011 13:46'!
initialize

	self playfield: OrcaPongGame new.! !

!OrcaPongManager methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 14:32'!
playfield

	^playfield! !

!OrcaPongManager methodsFor: 'as yet unclassified' stamp: 'robi 5/23/2011 14:32'!
playfield: aPlayfield

	playfield := aPlayfield! !
